#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "mys.h"

typedef float tip;

class vektor{
 public:
  tip x, y;
};

class bod {
 public:
  vektor poloha, rychlost;
  tip m;
};

class voda {
 public:
  bod *body;
  int pocet;
  tip A, B, C, D;
  tip f0, r0, rm;

  voda(int poc, tip m, tip _f0, tip _r0, tip _rm) {
    int i;
    pocet = poc;
    body = new bod[pocet];
    for (i = 0; i < pocet; i ++) {
      body[i].poloha.x = 200+random(10);
      body[i].poloha.y = 100+random(10);
      body[i].rychlost.x = 0;
      body[i].rychlost.y = 0;
      body[i].m = m;
    }

    f0 = _f0;
    r0 = _r0;
    rm = _rm;

    A = -f0/(rm*rm*r0);
    B = f0*(2*rm + r0)/(rm*rm*r0);
    C = -f0*(2*r0 + rm)/(rm*r0);
    D = f0;
  }


  void prepocti() {
    int i,j;
    tip sila, vzd;

    for (i = 0; i < pocet; i ++) {
      for (j = 0; j < pocet; j ++) {
	if (i != j) {
	  if ( (abs(body[i].poloha.x - body[j].poloha.x) < rm)&&(abs(body[i].poloha.y - body[j].poloha.y) < rm) ) {
	    vzd = sqrt(pow(body[i].poloha.x-body[j].poloha.x, 2) + pow(body[i].poloha.y-body[j].poloha.y, 2));
	    if ((vzd*body[i].m) != 0) sila = (A*pow(vzd, 3) + B*pow(vzd, 2) + C*vzd + D)/(vzd*body[i].m);
	    else sila = 0;
	    body[i].rychlost.x += (-body[i].poloha.x + body[j].poloha.x) * sila;
	    body[i].rychlost.y += (-body[i].poloha.y + body[j].poloha.y) * sila;
	  }
	  body[i].rychlost.x *= 0.9999;
	  body[i].rychlost.y *= 0.9999;
	}
      }
    }

  }

  void posun(void) {
    int i;
    for (i = 0; i < pocet; i ++) {
      body[i].poloha.x += body[i].rychlost.x;
      body[i].poloha.y += body[i].rychlost.y;
    }
  }

  void kresli(void) {
    int i;
    setcolor(11);
    for (i = 0; i < pocet; i ++) {
      putpixel(body[i].poloha.x, body[i].poloha.y, 11);
      putpixel(body[i].poloha.x+1, body[i].poloha.y, 11);
      putpixel(body[i].poloha.x-1, body[i].poloha.y, 11);
      putpixel(body[i].poloha.x, body[i].poloha.y+1, 11);
      putpixel(body[i].poloha.x, body[i].poloha.y-1, 11);
    }
  }

  void gravitace(tip g) {
    int i;
    for (i = 0; i < pocet; i ++) {
      body[i].rychlost.y += g;
    }
  }

  void podlaha(int p) {
    int i;
    for (i = 0; i < pocet; i ++) {
      if ((body[i].poloha.y + body[i].rychlost.y) > p) body[i].rychlost.y *= -0.5;
      if ((body[i].poloha.x + body[i].rychlost.x) < 200) body[i].rychlost.x *= -0.5;
      if ((body[i].poloha.x + body[i].rychlost.x) > 220) body[i].rychlost.x *= -0.5;
    }
  }

  void stop(int ktery, int x, int y) {
    if ((ktery > pocet)||(ktery < 0)) ktery = pocet - 1;
    body[ktery].poloha.x = x;
    body[ktery].poloha.y = y;
    body[ktery].rychlost.x = 0;
    body[ktery].rychlost.y = 0;
  }
};

void main() {
  int gm, gd, swp = 0;
  gd = 9;
  gm = 1;
  initgraph(&gd, &gm, "../bgi/");

  mouse mys;
  mys.set_off();
  mys.set_xy(20,20);
  voda kapka(50, 5, -2, 10, 20);
  while (!kbhit()) {
    mys.aktual();
//    kapka.stop(0, mys.get_x(), mys.get_y());
    kapka.prepocti();
    kapka.gravitace(0.1);
    kapka.podlaha(350);
    kapka.posun();
    setactivepage(swp);
    cleardevice();
    kapka.kresli();
    setvisualpage(swp);
    swp?swp --:swp ++;
    delay(10);
  }

  getch();
  closegraph();
}